using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using Exferia_KairosPRO.General;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_HorasExtrasCalculadas_Supervisores_Datos
    {

        #region Obtener
        public List<INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo> Obtener_Para_Listado(long _lng_idHoraExtraCalculadaCabecera)
        {
            KairosProEntities obj_KairosProEntities = null;

            List<INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo> lst_INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                string str_SQL =
                   " SELECT " +
                        nameof(INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo.id) + "=" + nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.id) + "," +
                        nameof(INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo.fechaAceptacionCancelacion) + "=" + nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion) + "," +
                        nameof(INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo.Empleado) + "=" + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.nombre) + "," +
                        nameof(INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo.estado) + "=" + nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + 
               " FROM " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
               " INNER JOIN " + nameof(KRS_Empleados) + " ON " + nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.idEmpleado) + "=" + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.id) + " and " +
                                                                 nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=" + nameof(KRS_Empleados) + "." + nameof(KRS_Empleados.codigoCliente) +
               " WHERE " +
                            " ( " +
                                nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + "=@estadoAceptado or  " +
                                nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + "=@estadoCancelado " +
                            " ) and " +
                            nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente and " +
                            nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@estadoAceptado",  Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_ACEPTADO.Codigo),
                     new SqlParameter("@estadoCancelado",  Variables_KairosPRO.G_MDL_ESTADOSOLICITUD_CANCELADO.Codigo),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                     new SqlParameter("@idHoraExtraCalculadaCabecera",  _lng_idHoraExtraCalculadaCabecera)
                };

                //Rellenar el Modelo
                lst_INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo = obj_KairosProEntities.Database.SqlQuery<INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Obtener_Para_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
            return lst_INTERNO_KRS_HorasExtrasCalculadas_Supervisores_Listado_Modelo;
        }


        #endregion

        #region MODELOS

        #region Modelo Listado
        private List<KRS_HorasExtrasCalculadas_Supervisores> g_lst_KRS_HorasExtrasCalculadas_Supervisores = null;

        public List<KRS_HorasExtrasCalculadas_Supervisores> Obtener_ModeloListado_Por_IdsHorasExtrasCabecera(List<long> _lst_idHoraExtraCalculadaCabecera)
        {
            try
            {

                if (_lst_idHoraExtraCalculadaCabecera != null && _lst_idHoraExtraCalculadaCabecera.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_HorasExtrasCalculadas_Supervisores),
                                                                                           nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_idHoraExtraCalculadaCabecera);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente and " +
                                            str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsHorasExtrasCabecera), true);
            }

            return g_lst_KRS_HorasExtrasCalculadas_Supervisores;
        }

        public List<KRS_HorasExtrasCalculadas_Supervisores> Obtener_ModeloListado_Por_IdHoraExtraCabecera(long _lng_idHoraExtraCalculadaCabecera)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera ";

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@idHoraExtraCalculadaCabecera", _lng_idHoraExtraCalculadaCabecera));
                lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdHoraExtraCabecera), true);
            }

            return g_lst_KRS_HorasExtrasCalculadas_Supervisores;
        }
        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_HorasExtrasCalculadas_Supervisores = obj_KairosProEntities.Database.SqlQuery<KRS_HorasExtrasCalculadas_Supervisores>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.id) + " , " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + " , " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + " , " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.idEmpleado) + " , " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + " , " +
                    nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion) + 
                " FROM " + nameof(KRS_HorasExtrasCalculadas_Supervisores);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Insertar(KRS_HorasExtrasCalculadas_Supervisores _mdl_KRS_HorasExtrasCalculadas_Supervisores)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                string str_SQL_Insert = " INSERT INTO " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                            " (" +
                                                    nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "," +
                                                    nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "," +
                                                    nameof(KRS_HorasExtrasCalculadas_Supervisores.idEmpleado) + "," +
                                                    nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + "," +
                                                    nameof(KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion) + 
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(KRS_HorasExtrasCalculadas_Supervisores.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idHoraExtraCalculadaCabecera," +
                                                "@codigoCliente," +
                                                "@idEmpleado," +
                                                "@estado," +
                                                "@fechaAceptacionCancelacion" +
                                            " ) ";

                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idHoraExtraCalculadaCabecera",  _mdl_KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera),
                    new SqlParameter("@codigoCliente", _mdl_KRS_HorasExtrasCalculadas_Supervisores.codigoCliente),
                    new SqlParameter("@idEmpleado", _mdl_KRS_HorasExtrasCalculadas_Supervisores.idEmpleado),
                    _mdl_KRS_HorasExtrasCalculadas_Supervisores.estado != null
                        ?   new SqlParameter("@estado", _mdl_KRS_HorasExtrasCalculadas_Supervisores.estado)
                        :   new SqlParameter("@estado",  DBNull.Value),
                   _mdl_KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion != null
                        ?   new SqlParameter("@fechaAceptacionCancelacion", _mdl_KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion.Value)
                        :   new SqlParameter("@fechaAceptacionCancelacion",  DBNull.Value)
                };

                //Insertar
                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar(KRS_HorasExtrasCalculadas_Supervisores _mdl_KRS_HorasExtrasCalculadas_Supervisores)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                string str_SQL_Update = " UPDATE " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                            " SET " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera," +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.idEmpleado) + "=@idEmpleado," +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + "=@estado," +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion) + "=@fechaAceptacionCancelacion" +
                                            " WHERE " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.id) + "=@id";

                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@idHoraExtraCalculadaCabecera",  _mdl_KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera),
                    new SqlParameter("@codigoCliente", _mdl_KRS_HorasExtrasCalculadas_Supervisores.codigoCliente),
                    new SqlParameter("@idEmpleado", _mdl_KRS_HorasExtrasCalculadas_Supervisores.idEmpleado),
                    _mdl_KRS_HorasExtrasCalculadas_Supervisores.estado != null
                        ?   new SqlParameter("@estado", _mdl_KRS_HorasExtrasCalculadas_Supervisores.estado)
                        :   new SqlParameter("@estado",  DBNull.Value),
                   _mdl_KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion != null
                        ?   new SqlParameter("@fechaAceptacionCancelacion", _mdl_KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion.Value)
                        :   new SqlParameter("@fechaAceptacionCancelacion",  DBNull.Value),
                   new SqlParameter("@id", _mdl_KRS_HorasExtrasCalculadas_Supervisores.id)
                };

                //Actualizar
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Actualizar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Actualizar_Estado(long _lng_idHoraExtraCalculadaCabecera, long _lng_idEmpleado,long _lng_CodigoCliente,string _str_Estado,DateTime _dtt_FechaAceptacionCancelacion)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                string str_SQL_Update = " UPDATE " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                            " SET " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.estado) + "=@estado," +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.fechaAceptacionCancelacion) + "=@fechaAceptacionCancelacion " +
                                            " WHERE " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera and " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente and " +
                                                nameof(KRS_HorasExtrasCalculadas_Supervisores.idEmpleado) + "=@idEmpleado";

                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@estado", _str_Estado),
                    new SqlParameter("@fechaAceptacionCancelacion", _dtt_FechaAceptacionCancelacion),
                    new SqlParameter("@idHoraExtraCalculadaCabecera",  _lng_idHoraExtraCalculadaCabecera),
                    new SqlParameter("@codigoCliente", _lng_CodigoCliente),
                    new SqlParameter("@idEmpleado", _lng_idEmpleado),
                };

                //Actualizar
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Actualizar_Estado), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_CodigoCliente,long _lng_idHoraExtraCalculadaCabecera)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            try
            {

                //Primer Intento de Borrado
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                        " WHERE " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera and " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idHoraExtraCalculadaCabecera", _lng_idHoraExtraCalculadaCabecera),
                    new SqlParameter("@codigoCliente", _lng_CodigoCliente)
                };
                #endregion

                //Delete
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_CodigoCliente, long _lng_idHoraExtraCalculadaCabecera, long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            try
            {

                //Primer Intento de Borrado
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                        " WHERE " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores.id) + "=@id and " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores.idHoraExtraCalculadaCabecera) + "=@idHoraExtraCalculadaCabecera and " +
                                            nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@id", _lng_id),
                    new SqlParameter("@idHoraExtraCalculadaCabecera", _lng_idHoraExtraCalculadaCabecera),
                    new SqlParameter("@codigoCliente", _lng_CodigoCliente)
                };
                #endregion

                //Delete
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_CodigoCliente, List<long> _lst_ids)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;
            try
            {
                if (_lst_ids != null && _lst_ids.Count > 0)
                {
                    //Primer Intento de Borrado
                    obj_KairosProEntities = new KairosProEntities();
                    obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                    #region Delete


                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_ids);

                    string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_HorasExtrasCalculadas_Supervisores) +
                                        " WHERE " +
                                             nameof(KRS_HorasExtrasCalculadas_Supervisores) + "." + nameof(KRS_HorasExtrasCalculadas_Supervisores.id) + " in (" + str_Filtro_IDS + ") and " +
                                             nameof(KRS_HorasExtrasCalculadas_Supervisores.codigoCliente) + "=@codigoCliente ";
                    
                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", _lng_CodigoCliente));
                    object[] arr_Parametros_Delete = lst_Parametros.ToArray();
                    #endregion

                    //Delete
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_HorasExtrasCalculadas_Supervisores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
